package agenda;

import java.io.*;
import java.lang.reflect.*;


public class ABSimpleDumpManager extends SimpleDumpManager
{
	
	
	private final AddressBook book;//la timetable che devo gestire
	
	
	public ABSimpleDumpManager(AddressBook book,File group) throws ClassNotFoundException,IOException
	{
		super(group);	
		this.book = book;		
		
	}//fine costruttore
	
	
	
	/*operazione di dump : dovrebbe essere atomica,
		se il sistema cade durante questa operazione
		i file sono lasciati in uno stato inconsistente
		e il recovery  impossibile o pericoloso
	*/
		
	public synchronized void dump() throws InvalidClassException,IOException
	{
		synchronized(book)
			{
				ObjectOutputStream dumpoos = new ObjectOutputStream(new FileOutputStream(dump));
				try
					{
						dumpoos.writeObject(book);
					}
					catch(NotSerializableException nse)	// impossibile che si verifichi questa eccezione, AddressBook  serializable
						{
							System.err.println(nse.toString());
						}
				dumpoos.flush();
				dumpoos.close();
		
				FileOutputStream logfos = new FileOutputStream(log);
				logfos.close();
			}		
	}

	
	/*operazione di recovery : si suppone sia eseguita su una book nuova,
		a partire da un dump file e un log file
	*/
	
	public synchronized void recovery() throws ClassNotFoundException,InvalidClassException,OptionalDataException,NotSerializableException,NoSuchMethodException,IllegalAccessException,IllegalArgumentException,InvocationTargetException,NullPointerException,ExceptionInInitializerError,StreamCorruptedException,IOException
	{
		synchronized(book)
			{				
				if(dump.exists())
					{
						ObjectInputStream dumpois = new ObjectInputStream(new FileInputStream(dump));
				
						AddressBook adb = ((AddressBook)dumpois.readObject());
						book.sum(adb);
						dumpois.close();
					}
					
				if(log.exists())
					{
						ObjectInputStream logois = new ObjectInputStream(new FileInputStream(log));
		
						LogAction temp = ((LogAction)logois.readObject());
	
						while((temp.getName())!="")
							{
								((book.getClass()).getMethod(temp.getName(),temp.getParameters())).invoke(book,temp.getArgs());
								temp = ((LogAction)logois.readObject());
							}
				
						logois.close();
					}//fine if
			}
	}//fine recovery

		
}//fine classe