package SOMA.agent;

import SOMA.agent.AgentWorker.*;
import SOMA.agent.mobility.*;

import java.io.*;


public abstract class AgendaAgent extends Agent
{
	
	public AgendaAgent()
	{
		super();
	}
	
	/*
		In questo modo non  possibile essere salvati dall'agentManager	
	*/
	
	public final void stop()
  {
    throw( new UnsupportedOperationException( "Abstract Agent doesn't support this operation." ) );
  }
	
	/*
		Uso invece questa procedura di ripristino personale	
	*/
	
	protected void save()
	{
		try
			{
				agentSystem.getEnvironment().agentManager.save();
				save("agent_" + getID().toString() + ".sav");
			}
			catch(IOException ioe)
				{
					agentSystem.getErr().println(ioe);
					ioe.printStackTrace();	
				}
	}//fine save
	
	
	protected void save(String fileName) throws IOException
	{
		ObjectOutputStream oos = new ObjectOutputStream( new FileOutputStream( new File( fileName ) ) );

    synchronized(worker)
    	{
    		//metti in idle il worker
    		Object oldStatus = worker.status;
    		worker.idle();
    		try
    			{
    				//salvato con activate uguale a false
    				SavedWorker saved = new SavedWorker( agentSystem.getEnvironment() , worker);
    				oos.writeObject( saved );
    			}
    			catch(AgentWorkerException awe)
    			{
    				agentSystem.getErr().println("ERROR: "+ this + awe);
    			}
				//rimettilo on
				worker.status = oldStatus;
    	}
    
    oos.close();

    agentSystem.getOut().println(this + " Status saved!" );

	}//fine save
	
}//fine classe