package agenda;


import agenda.gui.*;

import SOMA.*;
import SOMA.gui.*;
import SOMA.output.*;
import SOMA.explorer.*;
import SOMA.mobilePlace.*;
import SOMA.telnet.*;
import SOMA.naming.*;
import SOMA.agent.*;
import SOMA.agent.mobility.*;




import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.filechooser.*;




public class AgendaMain extends SomaMain
{
  
  
  
  public static void close()
	{
		/*
		Faccio sparire la GUI, invoco close del LocalSessionManager e stop dell'AgentServer
		
		Attendo la conclusione di tutti gli agenti di sessione ancora attivi e presenti
		
		Modifico il descrittore di stato del sistema (SystemStatus) notificando la chiusura dell'agenda e della rubrica
		
		*/
	}
  
  public static void normale()
	{
		/*
			Faccio partire la finestra di avvio "Nuova/Apri rubrica/agenda"
			Ascolto i bottoni e modifico SystemStatus di conseguenza (soprattutto bottoni apri)
			Se viene aperta un'agenda bisogna aprire prima anche una rubrica
			Tiro su il RubricaSession il LocalUserManager l'AgentServer la GUI collegata al LocalUser
			
		*/
	}
  
  
  public static void recovery()
	{
		/*
		Tiro su la rubrica e l'agenda che erano ancora aperte
		
		Se c'erano transazioni in corso
			riavvio tutti gli agenti coordinatori
			riavvio tutti gli agenti di sessione e spedisco nella mailbox di ognuno un RemoteSessionManager
			attendo la conclusione degli agenti di sessione
		
		Appena posso ripristino la GUI collegandola al LocalSessionManager e ripristino il server per gli agenti
			
		*/
	}
    
  
  public static void avvio(String args[])
  	{
  		/*
  		Carico lo stato del sistema da un file di nome noto
  		Osservando lo stato decido se avviare la procedura normale o quella di recovery
  		
  		In ogni caso prima faccio partire SOMA :
  			Costruisco una finestra con una riga di comando e una text area scrollabile per l'I/O di SOMA ( sia sistema sia places )
  			Faccio partire il sistema collegato a tale I/O
  			Apro una finestra per immettere nome dominio nome place e porta locali
  			Creo l'env locale con i parametri specificati
  			Restituisco l'env locale
  			
  		*/
  		
  		
  	}//fine avvio
  
  
  public static void provamain(String args[])throws Exception
	{
		
		SomaPanel somagui = somaGui(args);	
	
		SystemStatus.initStatus(new File("status.st"));//ricordarsi di distruggerlo se l'applicazione termina correttamente
		
		
		/* Creo un dominio sulla macchina locale: l'env viene creato correttamente
				e il menu principale viene aggiornato, ma non viene fatta la registrazione in altri domini
				o altre pippe varie che richiedano interazione con altri places
				
		*/	
		
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		int screenHeight = d.height;
		int screenWidth = d.width;
		
		
		SomaPanel domaingui = new SomaPanel();
		
		JFrame dFrame = new JFrame();
		
		dFrame.getContentPane().add(domaingui);
		dFrame.setTitle("Domain Frame");
		
		dFrame.setSize(screenWidth/2,screenHeight/2);
		dFrame.setLocation(0,screenHeight/2);
		dFrame.show();
  	
		 
		 Environment do1 = newDomain(root,"ProvaDomain1",5000,domaingui.getSOMAInputStream(),domaingui.getSOMAPrintStream(),domaingui.getSOMAPrintStream());
		
		/* Creo un place sulla macchina locale: l'env viene creato correttamente
				e il menu principale viene aggiornato, provo in seguito a registrarlo
				nel dominio creato prima				
		*/
		
		/*	
		Environment do2 = newDomain(root,"ProvaDomain2",8000,System.out);
		do2.domainNameService.register(InetAddress.getLocalHost(),5000);
		
		*/
		
		SomaPanel placegui = new SomaPanel();
		
		JFrame pFrame = new JFrame();
		
		pFrame.getContentPane().add(placegui);
		pFrame.setTitle("Place Frame");
		
		pFrame.setSize(screenWidth/2,screenHeight/2);
		pFrame.setLocation(screenWidth/2,screenHeight/2);
		pFrame.show();
  	
		
		
		Environment pl1 = newPlace(root,"ProvaDomain1","ProvaPlace1",6000,placegui.getSOMAInputStream(),placegui.getSOMAPrintStream(),placegui.getSOMAPrintStream());
		pl1.placeNameService.register(InetAddress.getLocalHost(),5000);
		
		/*
		Environment pl2 = newPlace(root,"ProvaDomain1","ProvaPlace2",7000,somagui.getSOMAInputStream(),somagui.getSOMAPrintStream(),somagui.getSOMAPrintStream());
		pl2.placeNameService.register(InetAddress.getLocalHost(),5000);
		
		*/
		
		User user1 = new User("pippo",pl1.placeID);
		//User user2 = new User("ciccio",pl2.placeID);		
		AddressBook partecipanti = new AddressBook();
		partecipanti.add(user1);
		//partecipanti.add(user2);
		Date from = new Date();
		Date to = from;
		
		
		TimeTable tt1 = new TimeTable();
		File group1 = new File("provagroup1.gp");
		File log1 = new File("provalog1.lg");
		File dump1 = new File("provadump1.dp");
		SimpleDumpManager.createGroup(group1,log1,dump1);
		TTSimpleDumpManager slm1 = new TTSimpleDumpManager(tt1,group1);
		Agenda agenda1 = new Agenda(tt1,slm1);
		
		AgentWorker server1 = pl1.agentManager.createAgent("agenda.agents.Server",agenda1,false,false);
		
		server1.start();
		
		/*
		TimeTable tt2 = new TimeTable();
		File group2 = new File("provagroup2.gp");
		File log2 = new File("provalog2.lg");
		File dump2 = new File("provadump2.dp");
		SimpleDumpManager.createGroup(group2,log2,dump2);
		TTSimpleDumpManager slm2 = new TTSimpleDumpManager(tt2,group2);
		Agenda agenda2 = new Agenda(tt2,slm2);
		
		AgentWorker server2 = pl2.agentManager.createAgent("agenda.agents.Server",agenda2,false,false);
		
		server2.start();
	*/
				
		AgentWorker coord = do1.agentManager.createAgent("agenda.agents.Coordinator",new Incontro("prova incontro",partecipanti,from,to),false,true);

		coord.start();
		
		/*
		while(((coord.getStatus()) != (SOMA.agent.AgentWorker.DEAD)))
				{}

		System.out.println("fine attesa coord");
		
		((agenda.agents.Server)server1.agent).shutDown();
		*/
		/**/
		
		System.out.println("fine prova main");
	}//fine provamain
  
 
 public static void demoDomain(String args[])throws Exception
	{
		SomaPanel somagui = somaGui(args);
		
		SystemStatus.initStatus(new File("status.st"));//ricordarsi di distruggerlo se l'applicazione termina correttamente
		
			/*
			Costruisco l'agenda		
		*/
		
		TimeTable tt = new TimeTable();
		File group = new File("provagroup.gp");
		File log = new File("provalog.lg");
		File dump = new File("provadump.dp");
		SimpleDumpManager.createGroup(group,log,dump);
		TTSimpleDumpManager slm = new TTSimpleDumpManager(tt,group);
		Agenda agenda = new Agenda(tt,slm);
		
		
		
		/* Creo un dominio sulla macchina locale: l'env viene creato correttamente
				e il menu principale viene aggiornato, ma non viene fatta la registrazione in altri domini
				o altre pippe varie che richiedano interazione con altri places
				
		*/	
		
		 PlaceID pl1 = new PlaceID( "DemoDomain1","DemoPlace1" );
		 PlaceID pl2 = new PlaceID( "DemoDomain1","DemoPlace2" );
		 
		 Environment do1 = newDomain(root,"DemoDomain1",5000,somagui.getSOMAInputStream(),somagui.getSOMAPrintStream(),somagui.getSOMAPrintStream());
		 
		 while(!((do1.placeNameService.getPlace(pl1) != null)&&(do1.placeNameService.getPlace(pl2) != null)))
		 	{Thread.sleep(1000);}
		 
		 /*
		 Costruisco una piccola rubrica e un incontro
		 */
		User me = new User("myself",do1.placeID);
		User user1 = new User("pippo",pl1);
		User user2 = new User("ciccio",pl2);		
		AddressBook partecipanti = new AddressBook();
		partecipanti.add(me);
		partecipanti.add(user1);
		partecipanti.add(user2);
		Date from = new Date();
		Date to = from;
		
		AgentWorker server = do1.agentManager.createAgent("agenda.agents.Server",agenda,false,false);
		
		server.start();
		
		
		AgentWorker coord = do1.agentManager.createAgent("agenda.agents.Coordinator",new Incontro("prova incontro",partecipanti,from,to),false,true);

		coord.start();
		
		
	}//fine demoDomain
 	
 	public static void demoPlace(String args[],String name)throws Exception
	{
		SomaPanel somagui = somaGui(args);	
	
		SystemStatus.initStatus(new File("status.st"));//ricordarsi di distruggerlo se l'applicazione termina correttamente
		
			/*
			Costruisco l'agenda		
		*/
		
		TimeTable tt = new TimeTable();
		File group = new File("provagroup.gp");
		File log = new File("provalog.lg");
		File dump = new File("provadump.dp");
		SimpleDumpManager.createGroup(group,log,dump);
		TTSimpleDumpManager slm = new TTSimpleDumpManager(tt,group);
		Agenda agenda = new Agenda(tt,slm);
		
		
		
		/* Creo un dominio sulla macchina locale: l'env viene creato correttamente
				e il menu principale viene aggiornato, ma non viene fatta la registrazione in altri domini
				o altre pippe varie che richiedano interazione con altri places
				
		*/	
		
	
		Environment pl1 = newPlace(root,"DemoDomain1",name,5000,somagui.getSOMAInputStream(),somagui.getSOMAPrintStream(),somagui.getSOMAPrintStream());
		
		
		AgentWorker server = pl1.agentManager.createAgent("agenda.agents.Server",agenda,false,false);
		
		server.start();
		
		
	}//fine demoPlace


	public static void main(String args[])throws Exception
	{
		provamain(args);
	}//fine main


}//fine classe