package agenda;

import SOMA.agent.*;
import SOMA.naming.*;


import java.io.*;

public class Alarm implements Runnable,Serializable
{
	private AgentID client;
	private transient AgentSystem system;
	private String callBackMsg;
	private long time;//in millisecondi
	private transient Thread clock = null;//riferimento al thread che sta eseguendo o sta per eseguire this runnable object
	
	private void timeElapsed()
	{
			system.sendMessage(new Message(new ProtocolMessage(callBackMsg),client,client));//il messaggio  mandato da se stesso
	}
	
	
	public Alarm(AgentID ag,AgentSystem sys,String callBackMsg,long time)
	{
		this.client = ag;
		this.system = sys;
		this.callBackMsg = callBackMsg;
		this.time = time;	
	}
	
	
	public synchronized boolean restart()
	{
		return ((cancel())? start() : false);//valutazione "and" cortocircuitata sicura
	}
	
	public synchronized boolean start()
	{
		if((clock == null)||(!(clock.isAlive())))//sfrutto il cortocircuito delle espressioni
			{
				clock = new Thread(this);
				clock.setDaemon(true);
				clock.start();				
				return true;
			}
			else return false;
	}//fine start
	
	public synchronized boolean cancel()
	{
		if(clock != null)
			{
				if(clock.isAlive())
					{
						clock.interrupt();
						try
							{
								clock.join();
							}
							catch(InterruptedException ie)
								{
									while(clock.isAlive());
								}
					};
				clock = null;
				return true;
			}
			else return false;
	}//fine cancel
	
	public void run()
	{
		try
			{
				Thread.sleep(time);
				timeElapsed();
			}
			catch(InterruptedException ie)
				{}
	}//fine run
	
	
}//fine classe