package agenda.agents;

import agenda.*;

import SOMA.agent.*;
import SOMA.agent.AgentWorker.*;
import SOMA.agent.mobility.*;
import SOMA.naming.*;

import java.util.*;
import java.io.*;


public class Coordinator extends AgendaAgent
{
	private Incontro meeting = null;//da inizializzare in putArgument	ok
  
  private AgentID stazionario;//inizializzare in esecuzione	ok
  
  private HashSet emigranti;//contiene AgentID's, inizializzare in esecuzione ok
  	
  private HashSet notDoneAgents;//contiene AgentID's, da inizializzare in esecuzione  ok
  
  private AgentPositionStore destinazioni;//destinazioni nominali non effettive, da inizializzare in esecuzione	ok
  	
  private int numberOfAgents = 0;//numero nominale non effettivo, init in putArgument	ok
  
  private transient SystemStatus system;//da inizializzare in esecuzione !	ok
  	  
  private transient boolean neverRestored = false;//da modificare nel costruttore per avere il comportamento normale	ok
  	
 	private boolean tuttiAndati = false;
  	
  private boolean commit;//da inizializzare in esecuzione
		
  private boolean commitDecision = false;
  
  private boolean end = false;
  
  
  
  private long precommitTimeout = 60 * 1000;//timeout sull'attesa dei ready in millisecondi
  
	private long endTimeout = 30 * 60 * 1000;//timeout generale scaduto il quale ce ne andiamo a casa senza pensarci due volte, in millisecondi
	
	private long doneTimeout = 2 * 60 * 1000;//timeout per l'attesa di messaggi done, in millisecondi
	
	
	public Coordinator()
	{
		super();
		neverRestored = true;
		mailbox = new Mailbox();
  
  }
  
  
  public void putArgument(Object obj)
	{
		if(obj instanceof Incontro)
			{
				this.meeting = ((Incontro)obj);
				numberOfAgents = meeting.getPartecipanti().size();
			}
		else//devo usare System.out perch agentSystem non  ancora valido
			System.out.println("agenda.AgentCoordinator : agente "+getID()+" : argomento non appropriato");
			
	}//fine putArgument

	
	private void waitForOthers(Set agents)
	{
		Iterator ait = agents.iterator();
		
		boolean wait = true;
		
		while(wait)
		{
			wait = false;
			
			while(ait.hasNext())
				{
					AgentID aid = ((AgentID)ait.next());
					
					PlaceID agentPosStored = agentSystem.getEnvironment().agentManager.agentPositionStore.get(aid);
					
					if(agentPosStored != null)
						if(agentPosStored.equals(aid.getHome()))
							wait = true;
				}//fine while
							
		}//fine while
	
	}//fine waitforothers
	
	
	private void wakeUpOthers()
	{
		Iterator eit = emigranti.iterator();
		
		while(eit.hasNext())
		{
			AgentID aid = ((AgentID)eit.next());
			
			PlaceID agentPosStored = agentSystem.getEnvironment().agentManager.agentPositionStore.get(aid);
			
			if(agentPosStored != null)
				if(agentPosStored.equals(aid.getHome()))
					{
						AgentWorker agw = agentSystem.getEnvironment().agentManager.agentWorkerStore.getWorker(aid);
						
						if(agw != null)
							try
								{
									agw.start();
								}
								catch(AgentWorkerException agwe)
									{
										agentSystem.getErr().println(agwe);
										agwe.printStackTrace();
									}
					
					}
			
		}//fine while
			
		if(stazionario != null)
			{
				AgentWorker agw = agentSystem.getEnvironment().agentManager.agentWorkerStore.getWorker(stazionario);
		
				if(agw != null)
					if(agw.getStatus() != AgentWorker.ON)
						try
							{
								agw.start();
							}
							catch(AgentWorkerException agwe)
										{
											agentSystem.getErr().println(agwe);
											agwe.printStackTrace();
										}
			}
		
					
	}//fine wakeupothers
		
	
	private void waitForDeath(Set agents)
	{
		waitForOthers(agents);
				
	}//fine waitfordeath
		
		
	private void fixPositions(Set agents)
	{
		Iterator ait = agents.iterator();
		
		while(ait.hasNext())
		{
			AgentID aid = ((AgentID)ait.next());
			
			agentSystem.getEnvironment().agentManager.agentPositionStore.put(aid,destinazioni.get(aid));
			
		}//fine while
		
	}//fine fixpositions

	
	
	/*Questo recovery forse funziona, il debugging ce lo dir
		In parole povere risveglio tutti gli agenti non ancora partiti,
		aspetto che muoiano spontaneamente e rimetto in sesto
		la tabella di agentManager
		*/
	
	
	private boolean recovery()
	{
		if(!(tuttiAndati))
			{
				//wakeUpOthers();
				//waitForDeath(emigranti);
				fixPositions(emigranti);
				tuttiAndati = true;
				save();
			};
			return true;
		
	}//fine recovery
	
	
	private void waitForDeparture(Set agents)
	{
		waitForOthers(agents);	
	
	}//fine waitfordeparture
	
	
	private boolean prepare()
	{
		emigranti = new HashSet();
		destinazioni = new AgentPositionStore();
		
		Iterator mit = meeting.getPartecipanti().iterator();
		
		while(mit.hasNext())
		{
			User us = ((User)mit.next());
			
			AgentWorker agw = agentSystem.getEnvironment().agentManager.createAgent("agenda.agents.SessionAgent",new SessionAgent.Argument(meeting,us,this.getID()),false,true);
			
			if(agw == null) return false;
			else
				{
					try
						{
							agw.start();
						}
						catch(AgentWorkerException agwe)
								{
									agentSystem.getErr().println(agwe);
									agwe.printStackTrace();
									return false;
								}
					
					if(us.getPlace().equals(this.getID().getHome())) stazionario = agw.agent.getID();
					else emigranti.add(agw.agent.getID());
					
					destinazioni.put(agw.agent.getID(),us.getPlace());
				
				}//fine if

		}//fine while
		
		notDoneAgents = new HashSet(emigranti);
		if(stazionario != null)
			notDoneAgents.add(stazionario);
		
		try
			{
				save();
				system.setRestoreReq(getID());
			}
			catch(IOException ioe)
					{
						agentSystem.getErr().println(ioe);
						ioe.printStackTrace();
						return false;	
					}
		
		return true;
			
	}//fine prepare

	
	
	private boolean inizio()
	{
		if(prepare())
		{
			sendToAll(ProtocolMessage.GO,notDoneAgents);
			
			agentSystem.getOut().println();
			agentSystem.getOut().println(this + " Spedito Messaggio GO a tutti i partecipanti");
			agentSystem.getOut().println();
			
			waitForDeparture(emigranti);
			tuttiAndati = true;
			save();
			return true;	
		}
		else//prepare  andata male
		{
			agentSystem.getErr().println(getClass().getName() + " : agente " + this + " : non  possibile avviare il protocollo");
			return false;
		}
		
	}//fine inizio
	
	
	private void precommitPhase()
	{
		String callBackMsg = "precommit timeout";
		Alarm timeout = new Alarm(getID(),agentSystem,callBackMsg,precommitTimeout);
		HashSet readyAgents = new HashSet();
		
		timeout.start();
		
		while(!(commitDecision))
		{
			Message msg = mailbox.getMessage();
			
			if(msg.message instanceof ProtocolMessage)
			{
				agentSystem.getOut().println();
				agentSystem.getOut().println(this + " Ricevuto Messaggio " + msg.message + " da " + msg.from);
				agentSystem.getOut().println();
			
				
				if((((ProtocolMessage)msg.message).isNotReadyMsg())||(((ProtocolMessage)msg.message).toString().equals(callBackMsg)))
				{
					commit = false;//cio abort
					commitDecision = true;	
				}
				else if(((ProtocolMessage)msg.message).isReadyMsg())
								{
									readyAgents.add(msg.from);
									if(readyAgents.size() >= numberOfAgents)
									{
										commit = true;
										commitDecision = true;
									};	
								}
								else mailbox.storeMessage(msg);//questo non dovrebbe accadere, anche perch modifica l'ordine cronologico dei messaggi e fa rischiare il loop
			};
		}//fine while
		
		timeout.cancel();//annulla se non  gi scattato
		
		save();
	}//fine precommitphase
	
	
	private void sendToAll(ProtocolMessage msg,Set dest)
	{
		Iterator dit = dest.iterator();
		
		while(dit.hasNext())
			{
				AgentID agid = ((AgentID)dit.next());
				if(agid != null)
				{
					Message toSend = new Message(msg,getID(),agid);
					
					agentSystem.sendMessage(toSend);
					
					agentSystem.getOut().println();
					agentSystem.getOut().println(this + " Spedito Messaggio " + toSend.message + " a " + toSend.to);
					agentSystem.getOut().println();
				}
					
			}//fine while		
	}//fine sendtoall
	
	
	
	private void commitPhase()
	{
		if(end || (notDoneAgents.isEmpty())) end();
		else
			{
				ProtocolMessage toSend = ((commit)? ProtocolMessage.COMMIT : ProtocolMessage.ABORT );
				
				sendToAll(toSend,notDoneAgents);
				
				agentSystem.getOut().println();
				agentSystem.getOut().println(this + " Spedito Messaggio " + toSend + " a tutti i partecipanti");
				agentSystem.getOut().println();
			
				
				String endMsg = "end timeout";
				String notDoneMsg = "done timeout";
				Alarm bigTimeout = new Alarm(getID(),agentSystem,endMsg,endTimeout);
				Alarm littleTimeout = new Alarm(getID(),agentSystem,notDoneMsg,doneTimeout);
				
				bigTimeout.start();				
				littleTimeout.start();
				
				while(!(end || (notDoneAgents.isEmpty())))
					{
						Message msg = mailbox.getMessage();
						
						if(msg.message instanceof ProtocolMessage)
						{
							agentSystem.getOut().println();
							agentSystem.getOut().println(this + " Ricevuto Messaggio " + msg.message + " da " + msg.from);
							agentSystem.getOut().println();
														
							if(((ProtocolMessage)msg.message).isDoneMsg())
								{
									notDoneAgents.remove(msg.from);
									save();
									if(notDoneAgents.isEmpty()) end();
								}//isDone
							else
								if((((ProtocolMessage)msg.message).isReadyMsg())||(((ProtocolMessage)msg.message).isNotReadyMsg()))
									{
										agentSystem.sendMessage(new Message(((commit)? ProtocolMessage.COMMIT : ProtocolMessage.ABORT ),getID(),msg.from));
										bigTimeout.restart();
									}//isReady or isNotReady
								else
									if(((ProtocolMessage)msg.message).toString().equals(notDoneMsg))
										{
											sendToAll(((commit)? ProtocolMessage.COMMIT : ProtocolMessage.ABORT ),notDoneAgents);
											littleTimeout.restart();
										}//scattato timeout piccolo
									else
										if(((ProtocolMessage)msg.message).toString().equals(endMsg))
											end();//scattato timeout grande
										else mailbox.storeMessage(msg);//questo non dovrebbe accadere, anche perch modifica l'ordine cronologico dei messaggi e fa rischiare il loop
						};
					}//fine while
					
					littleTimeout.cancel();
					bigTimeout.cancel();
			}//fine if
	}//fine commitphase

	private void end()
	{
		agentSystem.getOut().println();
		agentSystem.getOut().println(this + " Fase di chiusura del protocollo");
		agentSystem.getOut().println();
				
		if(!(end))
			{
				end = true;
				save();
			};
		try
			{
				system.report(new SessionReport(getID(),stazionario,emigranti,destinazioni,commit,notDoneAgents));
				system.resetRestoreReq(getID());
			}
			catch(IOException ioe)
					{
						agentSystem.getErr().println(ioe);
						ioe.printStackTrace();
					}
	
	}//fine end
	
	public void run()	
	{
		if(meeting != null)
			{
				system = SystemStatus.getInstance();
		
				if((neverRestored)? inizio() : recovery())
					{
						if(!(commitDecision)) precommitPhase();
						commitPhase();
					};
			}
		else
			agentSystem.getErr().println("agenda.AgentCoordinator : agente "+getID()+" : argomento non appropriato");
			
	}//fine run
	

}//fine classe