package agenda;

import java.io.*;

public class ProtocolMessage implements Serializable
{
	public static final ProtocolMessage GO = new ProtocolMessage("go");
	public static final ProtocolMessage READY = new ProtocolMessage("ready");
	public static final ProtocolMessage NOT_READY = new ProtocolMessage("not ready");
	public static final ProtocolMessage COMMIT = new ProtocolMessage("commit");
	public static final ProtocolMessage ABORT = new ProtocolMessage("abort");
	public static final ProtocolMessage DONE = new ProtocolMessage("done");
		
	
	private String message;
	
	
	public ProtocolMessage(String message)
	{
		this.message = message;
	}
	
	
	public boolean isGoMsg()
	{
		return message.equals(GO.toString());
	}

	
	public boolean isReadyMsg()
	{
		return message.equals(READY.toString());
	}
	
	public boolean isNotReadyMsg()
	{
		return message.equals(NOT_READY.toString());
	}
	
	public boolean isCommitMsg()
	{
		return message.equals(COMMIT.toString());
	}
	
	public boolean isAbortMsg()
	{
		return message.equals(ABORT.toString());
	}

	public boolean isDoneMsg()
	{
		return message.equals(DONE.toString());
	}
	

	
	public String toString()
	{
		return message;
	}
	
	
}//fine classe