package agenda;

import java.util.*;
import java.io.*;
import java.lang.reflect.*;


public class RemoteUserManager extends Agenda
{
		
	public RemoteUserManager(TimeTable agenda,SimpleDumpManager slm)
	{
		super(agenda,slm);
	}
	
	
	public void close()throws InvalidClassException,IOException
	{
		lm.dump();	
	}
	
	public boolean add(Incontro inc)throws InvalidClassException,NotSerializableException,IOException
		{
			synchronized(agenda)
			{
				if(agenda.add(inc))
						{
							Object[] arg = new Object[1];
							arg[0] = inc;
							Class[] par = new Class[1];
							par[0] = inc.getClass();
							try
								{
									lm.logaction((agenda.getClass()).getMethod("add",par),arg);
								}
								catch(NoSuchMethodException nsme)
										{
											System.err.println(nsme.toString());
										}
							lm.dump();
							return true;
						}
				else return false;
			}	
		}
	
	public boolean testforadd(Incontro inc)
		{
			return agenda.testforadd(inc);
		}
	
	public boolean remove(Incontro inc)throws InvalidClassException,NotSerializableException,IOException
		{
			synchronized(agenda)
			{
				if(agenda.remove(inc))
						{
							Object[] arg = new Object[1];
							arg[0] = inc;
							Class[] par = new Class[1];
							par[0] = inc.getClass();
							try
								{
									lm.logaction((agenda.getClass()).getMethod("remove",par),arg);
								}
								catch(NoSuchMethodException nsme)
										{
											System.err.println(nsme.toString());
										}
							lm.dump();
							return true;
						}
				else return false;
			}	

		}
	
	public void clear()throws InvalidClassException,NotSerializableException,IOException
		{
			synchronized(agenda)
			{
				agenda.clear();
				try
					{
						lm.logaction((agenda.getClass()).getMethod("clear",null),null);
					}
					catch(NoSuchMethodException nsme)
										{
											System.err.println(nsme.toString());
										}
				
				lm.dump();
			}	
	
		}
	
	public boolean contains(Incontro inc)
		{
			return agenda.contains(inc);
		}
	
	public boolean isEmpty()
		{
			return agenda.isEmpty();
		}
	
	public Iterator iterator()
		{
			return agenda.iterator();
		}
	
	public TimeTable testforadd(TimeTable ttb)
		{
			return agenda.testforadd(ttb);
		}
	
	public void sum(TimeTable ttb)throws InvalidClassException,NotSerializableException,IOException

		{
			synchronized(agenda)
			{
				agenda.sum(ttb);
				Object[] arg = new Object[1];
				arg[0] = ttb;
				Class[] par = new Class[1];
				par[0] = ttb.getClass();
				try
					{
						lm.logaction((agenda.getClass()).getMethod("sum",par),arg);
					}
					catch(NoSuchMethodException nsme)
										{
											System.err.println(nsme.toString());
										}
				lm.dump();
			}	
		}
	
	public TimeTable difference(TimeRange tr)
		{
			return agenda.difference(tr);
		}
	
	public TimeTable difference(TimeTable ttb)
		{
			return agenda.difference(ttb);
		}
	
	public TimeTable intersection(TimeRange tr)
		{
			return agenda.intersection(tr);
		}
	
	public TimeTable intersection(TimeTable ttb)
		{
			return agenda.intersection(ttb);
		}


	
}//fine remoteuser