package agenda;

import java.util.*;
import java.io.*;
import java.lang.reflect.*;


public class RubricaSession extends SessionManager
{
		
	private AddressBook rubrica;
	private ABSimpleDumpManager sdm;
	
	public RubricaSession(Rubrica rubrica)
	{
		this.rubrica = rubrica.getAB();
		this.sdm = rubrica.getSDM();
	}
	
	
	public Object getLock()
		{
			return this.rubrica;			
		}
	
	
	public void open()
	{}
	
	public void close()throws InvalidClassException,IOException
	{
		sdm.dump();	
	}
	
	public boolean add(User us)throws InvalidClassException,NotSerializableException,IOException
		{
			synchronized(rubrica)
			{
				if(rubrica.add(us))
						{
							Object[] arg = new Object[1];
							arg[0] = us;
							Class[] par = new Class[1];
							par[0] = us.getClass();
							try
								{
									sdm.logaction((rubrica.getClass()).getMethod("add",par),arg);
								}
								catch(NoSuchMethodException nsme)
										{
											System.err.println(nsme.toString());
										}
							sdm.dump();
							return true;
						}
				else return false;
			}	
		}
	
	
	
	public boolean remove(User us)throws InvalidClassException,NotSerializableException,IOException
		{
			synchronized(rubrica)
			{
				if(rubrica.remove(us))
						{
							Object[] arg = new Object[1];
							arg[0] = us;
							Class[] par = new Class[1];
							par[0] = us.getClass();
							try
								{
									sdm.logaction((rubrica.getClass()).getMethod("remove",par),arg);
								}
								catch(NoSuchMethodException nsme)
										{
											System.err.println(nsme.toString());
										}
							sdm.dump();
							return true;
						}
				else return false;
			}	

		}
	
	public void clear()throws InvalidClassException,NotSerializableException,IOException
		{
			synchronized(rubrica)
			{
				rubrica.clear();
				try
					{
						sdm.logaction((rubrica.getClass()).getMethod("clear",null),null);
					}
					catch(NoSuchMethodException nsme)
										{
											System.err.println(nsme.toString());
										}
				
				sdm.dump();
			}	
	
		}
	
	public boolean contains(User us)
		{
			return rubrica.contains(us);
		}
	
	public boolean isEmpty()
		{
			return rubrica.isEmpty();
		}
	
	public Iterator iterator()
		{
			return rubrica.iterator();
		}
	
	
	
	public void sum(AddressBook adb)throws InvalidClassException,NotSerializableException,IOException

		{
			synchronized(rubrica)
			{
				rubrica.sum(adb);
				Object[] arg = new Object[1];
				arg[0] = adb;
				Class[] par = new Class[1];
				par[0] = adb.getClass();
				try
					{
						sdm.logaction((rubrica.getClass()).getMethod("sum",par),arg);
					}
					catch(NoSuchMethodException nsme)
										{
											System.err.println(nsme.toString());
										}
				sdm.dump();
			}	
		}
	
	


	
}//fine rubricasession