package agenda.agents;

import agenda.*;

import SOMA.agent.*;
import SOMA.naming.*;

import java.net.*;
import java.io.*;


public class Server extends AgendaAgent
{
	private transient Agenda agenda = null;// init in putArgument
		
	private transient DatagramSocket so;
	
	private boolean run;

	
	private static int port;
	public static final int timeout = 1000;// in millisecondi
	public static final int bufsize = 400;//questa  una stima in bytes della grandezza della Serialized Form di AgentID
	public static final byte[] ACK = {((byte)77)};
  
	
	public static int getPort()
	{
		return port;
	}
	
	public Server() throws SocketException
	{
		super();
		
		so = new DatagramSocket();
		port = so.getLocalPort();				
		
  	run = true;
	}
	
	
	public void putArgument(Object obj)
	{
		if(obj instanceof Agenda)
					this.agenda = ((Agenda)obj);
  	else run = false;
		
	}
	
		
	public void shutDown()
	{
		run = false;	
	}
	
	
	public void run()	
	{
		byte[] buffer = new byte[bufsize];
		DatagramPacket rcvpacket = new DatagramPacket(buffer,buffer.length);    				
		
		
		try
			{				
				so.setSoTimeout(timeout);
			}
			catch(SocketException se)
				{//non posso settare il timeout 
					run = false;
					agentSystem.getErr().println(se);
					se.printStackTrace();
				}
				
		while(run)
			{
				try
    			{
    				so.receive(rcvpacket);//con timeout
    				//se lancia un'IOException  perch la socket ha dei problemi di sistema
    				ObjectInputStream ois = new ObjectInputStream(new ByteArrayInputStream(rcvpacket.getData()));
 						//la riga sopra pu lanciare StreamCorrupted o IOException
 						//in ogni caso sono problemi di sistema non correggibili
 						AgentID mittente = ((AgentID)ois.readObject());
 						//lancia ClassNotFoundException che non  una IOException !
 						//oppure EOF se il buffer  troppo corto per contenere l'oggetto
 						ois.close();
 						//lancia generica IOException, problemi di sistema
 						
 						agentSystem.sendMessage(new Message(new RemoteUserSession(agenda),getID(),mittente));
 						so.send(new DatagramPacket(ACK,ACK.length,rcvpacket.getAddress(),rcvpacket.getPort()));
 						
 					}
    			catch(InterruptedIOException iioe)
							{
								// scattato il timeout su receive
							}
    			catch(Exception e)
    					{//in ogni caso l'unica soluzione  fermarsi
    						run = false;
    						agentSystem.getErr().println(e);
    						e.printStackTrace();
    					}
    		}//fine while
    	
    	so.close();//non lancia eccezioni
  
  }//fine run

}//fine agentserver