package agenda.agents;

import agenda.*;

import SOMA.agent.*;
import SOMA.agent.mobility.*;
import SOMA.naming.*;

import java.net.*;
import java.io.*;


public class SessionAgent extends Agent
{
	private AgentID coordinator = null;//da init nella putArgument
	
	private User destinazione = null;//da init nella putArgument
	
	private Incontro meeting = null;//da init nella putArgument
		
	private transient RemoteUserSession session;//da init in exec !
		
	//private transient SystemStatus system;//da inizializzare in esecuzione !
  	  
  private transient boolean neverrestored = false;//da modificare nel costruttore per avere il comportamento normale

	private boolean arrivato = false;
	
	private boolean locked = false;
	
	private boolean ready = false;

	private boolean readyDecision = false;
	
	private boolean commit = false;

	private boolean commitDecision = false;
	
	private boolean outOfTime = false;
	
	private boolean done = false;


	private int soTimeout = 1000;//timeout sulla socket per ottenere una risposta dal server, in millisecondi
	
	private long goTimeout = 2 * 60 * 1000;//timeout dall'inizio esecuzione per ottenere il go dal coordinatore, in millisecondi
	
	private long commitTimeout = 5 * 60 * 1000;//timeout sulla risposta dal coordinatore che deve dare il commit o l'abort, in millisecondi
	
	private long endTimeout = 30 * 60 * 1000;//timeout generale scaduto il quale ce ne andiamo a casa senza pensarci due volte, in millisecondi
	
		
	
	public SessionAgent()
	{
		super();
		neverrestored = true;
		mailbox = new SessionMailbox();
  }
  
  
  public void putArgument(Object obj)
	{
		if(obj instanceof SessionAgent.Argument)
			{
				this.coordinator = ((SessionAgent.Argument)obj).getBoss();
				this.destinazione = ((SessionAgent.Argument)obj).getGoal();
				this.meeting = ((SessionAgent.Argument)obj).getMeeting();

			}
		else//devo usare System.out perch agentSystem non  ancora valido
			System.out.println("agenda.SessionAgent : agente "+getID()+" : argomento non appropriato");
	
		
	}//fine putArgument
		
		
		
	public void setTraceable( boolean traceable )
  {
    this.traceable = traceable;

    if( traceable && (mailbox == null) )
        mailbox = new SessionMailbox();
  }
  
  
  //	public void stop(){}//fine stop


	/*metodo che va chiamato all'arrivo in un place
		per interagire con Agentserver via Socket e
		ricevere un RemoteUserSession nella mailbox
	*/
	
	/*ATTENZIONE !!! attualmente c' un'attesa bloccante sulla mailbox
	sarebbe meglio ricevere un ack sulla socket
	e poi guardare la mailbox se mai
	*/
	
	/* FATTO !!! */
	
	private RemoteUserSession getSMFromServer()
	{
		if(Server.getPort() > 0)
			{
				try
				{
					ByteArrayOutputStream baos = new ByteArrayOutputStream();
					ObjectOutputStream oos = new ObjectOutputStream(baos);//possibile IOException, eccezione di sistema
			
					oos.writeObject(getID());//lancia eccezioni sulla classe dell'oggetto o generica IOException
			
					byte[] msg = baos.toByteArray();
					DatagramPacket sndpacket = new DatagramPacket(msg,msg.length,InetAddress.getLocalHost(),Server.getPort());
			
					DatagramSocket so = new DatagramSocket();//possibile SocketException, eccezione di sistema
			
					so.send(sndpacket);//lancia IOException per cause di sistema
			
					oos.close();//lancia IOException per cause di sistema
					baos.close();//lancia IOException per cause di sistema		
				
					DatagramPacket rcvpacket = new DatagramPacket(new byte[Server.ACK.length],Server.ACK.length);
			
					so.setSoTimeout(soTimeout);//lancia SocketException
					so.receive(rcvpacket);//lancia IOException e IOInterrupted
			
					so.close();
			
					return ((SessionMailbox)mailbox).getSM();
		
				}
				catch(InterruptedIOException iioe)
				{
					agentSystem.getErr().println(iioe);
					agentSystem.getErr().println("agenda.SessionAgent : agente "+getID()+" : server non disponibile");
					return null;
				}		
				catch(IOException ioe)
				{
					agentSystem.getErr().println(ioe);
					ioe.printStackTrace();
					return null;//si  verificato un errore	
				}
			}
			else
				{
					agentSystem.getErr().println("agenda.SessionAgent : agente "+getID()+" : server non disponibile");
					return null;
				}
				
	}//fine getSMFromServer
		
			
	private RemoteUserSession getSMFromSystem()//il sistema conosce gi il mio ID
	{
		return ((SessionMailbox)mailbox).getSM();
	}//fine getSMFromSystem
	
	
	
	private RemoteUserSession getSessionManager()
	{
		if(arrivato)
			{
				if((neverrestored)&&(!(locked))) return getSMFromServer();
				if((!(neverrestored))&&(locked)) return getSMFromSystem();
				return null;
			}
		else return null;
	
	}//fine getSessionManager
	
	
	
	private void inizio()
		{
			boolean go = false;
			boolean safe = true;
			
			String callBackMsg = "don't go";
			Alarm timeout = new Alarm(getID(),agentSystem,callBackMsg,goTimeout);
			
			timeout.start();
			
			while((!(go))&&(safe))//semaforo giallo
				{
					Message msg = mailbox.getMessage();
					
					if((msg.message)instanceof ProtocolMessage)
					{
						if(((ProtocolMessage)msg.message).isGoMsg()) go = true;//semaforo verde
						else
							if(((ProtocolMessage)msg.message).toString().equals(callBackMsg)) safe = false;//semaforo rosso
							else mailbox.storeMessage(msg);//questo non dovrebbe accadere, anche perch modifica l'ordine cronologico dei messaggi e fa rischiare il loop
					};
				}//fine while
			
			timeout.cancel();
			
			if((safe)&&(go))//semaforo verde
					{
						if(destinazione.getPlace().equals(getID().getHome()))
							{//questo per simulare il trasporto
								start = "atArrival";
								neverrestored = false;
								atArrival();
							}
						else
							try
								{
									go(destinazione.getPlace(),"atArrival");
								}
								catch(CantGoException cgoe)
									{
										agentSystem.getErr().println(cgoe);
										cgoe.printStackTrace();	
									}
					}
			else//semaforo rosso
					{
						agentSystem.getErr().println("agenda.SessionAgent : agente "+getID()+" : termino in fase di preparazione");	
					}
		
		}//fine inizio
	
	
	public void atArrival()
		{
			if(agentSystem.getPlaceID().equals(destinazione.getPlace()))
				{
					agentSystem.getOut().println();
					agentSystem.getOut().println(this + " arrivato in " + agentSystem.getPlaceID());
					agentSystem.getOut().println();
			
					
					start = "run";
					neverrestored = true;
					arrivato = true;
					
					try
						{
							agentSystem.getEnvironment().agentManager.save();//posso anche registrarmi con systemstatus oppure aspetto di avere il session manager
						}
						catch(IOException ioe)
								{
									agentSystem.getErr().println(ioe);
									ioe.printStackTrace();	
								}
					
					run();
				
				};
				
		}//fine atarrival
	
	
	/*
	Si entra in questo metodo se non si ha gi preso una decisione sul ready
	Si suppone che la sessione sia aperta quindi session  un riferimento valido
	*/	
	
	private void testPhase()
	{
		ready = session.testForAdd(meeting);
		readyDecision = true;
		try
			{
				agentSystem.getEnvironment().agentManager.save();
			}
			catch(IOException ioe)
					{
						agentSystem.getErr().println(ioe);
						ioe.printStackTrace();	
					}		
	}//fine testPhase
	
	
	/*
	Fase di comunicazione con il coordinatore: possono esserci due esiti,
	si arriva ad una decisione sul commit oppure scatta il timeout.
	In quest'ultimo caso il protocollo va a monte e se ne viola la semantica
	cio si abortisce la transazione unilateralmente
	*/
	
	private void precommitPhase()
	{
		Message toSend = new Message(((ready)? ProtocolMessage.READY : ProtocolMessage.NOT_READY ),getID(),coordinator);
		
		agentSystem.sendMessage(toSend);
		
		agentSystem.getOut().println();
		agentSystem.getOut().println(this + " Spedito Messaggio " + toSend.message + " a " + toSend.to);
		agentSystem.getOut().println();
			
		
		String endMsg = "end timeout";
		String notCommitMsg = "commit timeout";
		Alarm bigTimeout = new Alarm(getID(),agentSystem,endMsg,endTimeout);
		Alarm littleTimeout = new Alarm(getID(),agentSystem,notCommitMsg,commitTimeout);
				
		bigTimeout.start();				
		littleTimeout.start();
				
		while(!(commitDecision || outOfTime))
		{
			Message msg = mailbox.getMessage();
						
			if(msg.message instanceof ProtocolMessage)
				{
					agentSystem.getOut().println();
					agentSystem.getOut().println(this + " Ricevuto Messaggio " + msg.message + " da " + msg.from);
					agentSystem.getOut().println();
		
					
					if(((ProtocolMessage)msg.message).isCommitMsg())
						{
							commit = true;
							commitDecision = true;
						}//isCommit
					else
						if(((ProtocolMessage)msg.message).isAbortMsg())
							{
								commit = false;
								commitDecision = true;
							}//isAbort
						else
							if(((ProtocolMessage)msg.message).toString().equals(notCommitMsg))
								{
									agentSystem.sendMessage(new Message(((ready)? ProtocolMessage.READY : ProtocolMessage.NOT_READY ),getID(),coordinator));
									littleTimeout.restart();
								}//scattato timeout piccolo
							else
								if(((ProtocolMessage)msg.message).toString().equals(endMsg))
									outOfTime = true;//scattato timeout grande
								else mailbox.storeMessage(msg);//questo non dovrebbe accadere, anche perch modifica l'ordine cronologico dei messaggi e fa rischiare il loop
				};
		
		}//fine while
					
		littleTimeout.cancel();
		bigTimeout.cancel();
		
		try
			{
				agentSystem.getEnvironment().agentManager.save();
			}
			catch(IOException ioe)
					{
						agentSystem.getErr().println(ioe);
						ioe.printStackTrace();	
					}		
		
	}//fine precommitphase
	
	/*Questo metodo assume che si sia raggiunta una decisione sul commit
	ed esegue gli ordini
	*/
	
	private void commitPhase()
	{
		try
			{
				if(commit)
						session.add(meeting);
				done = true;
				agentSystem.getEnvironment().agentManager.save();
			}
			catch(IOException ioe)
					{
						agentSystem.getErr().println(ioe);
						ioe.printStackTrace();					
					}
		if(done)
				sendDone();
	}//fine commitPhase
	
	/*
	Adesso  un po' grezzo ma potrebbe diventare un piccolo protocollo
	con risposta (ACK) da parte del coordinatore e timeout
	*/
	
	private void sendDone()
	{
		Message toSend = new Message(ProtocolMessage.DONE,getID(),coordinator);
		
		agentSystem.sendMessage(toSend);
		
		agentSystem.getOut().println();
		agentSystem.getOut().println(this + " Spedito Messaggio " + toSend.message + " a " + toSend.to);
		agentSystem.getOut().println();
		
	}//fine sendDone
	
	
	public void run()	
	{
		if((coordinator != null)&&(destinazione != null)&&(meeting != null))
		{
			if((neverrestored)&&(!(arrivato))) inizio();//questa riga  eseguita solo sul place home e solo se l'agente non ha subito crash
			if(arrivato)
				{
					if(done) sendDone();
					else
						if(neverrestored != locked)
							{
								session = getSessionManager();
								
								if(session != null)
									{
										agentSystem.getOut().println();
										agentSystem.getOut().println(this + " Ottenuto Session Manager");
										agentSystem.getOut().println();
		
										
										synchronized(session.getLock())
											{
												boolean validSession;
												try
													{
														if(!(locked))
															{
																session.open(getID());
																locked = true;
																agentSystem.getEnvironment().agentManager.save();
																
															};
															validSession = true;
													}
													catch(IOException ioe)
															{
																agentSystem.getErr().println(ioe);
																ioe.printStackTrace();
																validSession = false;
															}
															
													if(validSession)
														{
															agentSystem.getOut().println();
															agentSystem.getOut().println(this + " Inizio Sessione");
															agentSystem.getOut().println();
		
															if(!(readyDecision)) testPhase();
															if((!(commitDecision))&&(!(outOfTime))) precommitPhase();
															if((commitDecision)&&(!(outOfTime))) commitPhase();
															
															agentSystem.getOut().println();
															agentSystem.getOut().println(this + " Fine Sessione");
															agentSystem.getOut().println();
		
														}
														
													try
														{
															if(locked)
																{
																	locked = false;
																	agentSystem.getEnvironment().agentManager.save();
																};
															session.close(getID());
														}
														catch(IOException ioe)
																{
																	agentSystem.getErr().println(ioe);
																	ioe.printStackTrace();	
																}
																											
											}//rilascio lock	
									};//session != null
							};//((arrivato)&&(neverrestored != locked))
				}//arrivato
		}//((coordinator != null)&&(destinazione != null)&&(meeting != null))
	  else
	  	agentSystem.getErr().println("agenda.SessionAgent : agente "+getID()+" : argomento non appropriato");
	  	
	}//fine run
	

public static class Argument
	{
		private AgentID boss;
	
		private User goal;
	
		private Incontro meeting;

		
		public Argument(Incontro inc,User us,AgentID boss)
		{
			this.meeting = inc;
			this.goal = us;
			this.boss = boss;
			
		}
		

		public AgentID getBoss()
		{
			return this.boss;
		}

		public User getGoal()
		{
			return this.goal;
		}

		public Incontro getMeeting()
		{
			return this.meeting;
		}

	}//fine Argument




}//fine classe