package agenda;


import SOMA.agent.*;


public class SessionMailbox extends Mailbox
{
  private transient RemoteUserSession sm = null;

  public SessionMailbox()
  {super();}


/**
  * Metodo implicitamente chiamato dal sistema quando arriva un messaggio
  */
  public synchronized void storeMessage( Message message )
  {
    if((message.message) instanceof RemoteUserSession)
    	{
    		if(sm == null)
    			{
    				sm = ((RemoteUserSession)message.message);
    				notifyAll();
    			};
    	}
    else super.storeMessage(message);
  }

/**
  * Restituisce il session manager in mailbox. La chiamata e' sospensiva
  * ma esiste la possibilita' di verificare se la Maibox e' piena
  */

  public synchronized RemoteUserSession getSM()
  {
    try
    {
	    while( sm == null )
	      wait();
    }
    catch( Exception e )
    {
      e.printStackTrace();
    }

    return sm;
  }

  /**
    * Verifica se  presente il session manager in Mailbox.
    */
  public synchronized boolean isSM()
  {
    return (sm != null);
  }
  
}//fine classe





/*
  public String toString()
  {
    return super.toString()+"\n[" + obligMess.size() + " ObligMessages]\n";
  }
*/

 