package agenda;

import java.io.*;
import java.lang.reflect.*;


public class TTDoubleDumpManager extends LogManager
{
	private class DumpMark implements Serializable
	{
		private DumpMark(File overridedump,File recoverydump)
			{
				ovrdump = overridedump;
				ovrdumpfn =  overridedump.getPath();
				
				rcvdump = recoverydump;
				rcvdumpfn =  recoverydump.getPath();
			}
		
		private File rcvdump;
		private String rcvdumpfn;
		
		private File ovrdump;
		private String ovrdumpfn;
		
	}//fine classe DumpMark
	
		
	private final DumpMark FIRST;//costanti che servono a stabilire quale file ha il ruolo di recovery e quale di override
	private final DumpMark SECOND;
	
	private DumpMark actual;//stabilisce la costante che  valida in questo momento
	
	private String frstdumpfn;
	private String scnddumpfn;
	private String markfn;
	
	
	private File frstdump;
	private File scnddump;
	private File mark;//file che registra la marca di dump cio chi  il recovery e chi l'override

	private final TimeTable table;//la timetable che devo gestire
	
	public TTDoubleDumpManager(TimeTable table,File group) throws ClassNotFoundException,IOException
	{
		this.table = table;		
		
		ObjectInputStream groupois = new ObjectInputStream(new FileInputStream(group));
		
		log = ((File)groupois.readObject());
		frstdump = ((File)groupois.readObject());
		scnddump = ((File)groupois.readObject());
		mark = ((File)groupois.readObject());
		
		groupois.close();

		logfn = log.getPath();
		frstdumpfn = frstdump.getPath();
		scnddumpfn = scnddump.getPath();
		markfn = mark.getPath();
		
		log.createNewFile();		
		frstdump.createNewFile();
		scnddump.createNewFile();
		
		FIRST = new DumpMark(frstdump,scnddump);
		SECOND = new DumpMark(scnddump,frstdump);
		
		if(mark.createNewFile())
					{
						actual = FIRST;
						ObjectOutputStream markoos = new ObjectOutputStream(new FileOutputStream(mark));
						markoos.writeObject(actual);
						markoos.flush();
						markoos.close();
					}
		else
				{
					ObjectInputStream markois = new ObjectInputStream(new FileInputStream(mark));
					actual = ((DumpMark)markois.readObject());
					markois.close();
				}
		
	}//fine costruttore

	/*operazione di dump : dovrebbe essere atomica,
		se il sistema cade durante questa operazione
		i file sono lasciati in uno stato inconsistente
		e il recovery  impossibile o pericoloso
	*/
		
	public synchronized void dump() throws InvalidClassException,NotSerializableException,IOException
	{
		synchronized(table)
			{				
				ObjectOutputStream dumpoos = new ObjectOutputStream(new FileOutputStream(actual.ovrdump));
				dumpoos.writeObject(table);					
				dumpoos.flush();
				dumpoos.close();
		
				if(actual==FIRST)actual=SECOND;
				else actual=FIRST;
			
				ObjectOutputStream markoos = new ObjectOutputStream(new FileOutputStream(mark));
				markoos.writeObject(actual);
				markoos.flush();
				markoos.close();
		
				FileOutputStream logfos = new FileOutputStream(log);
				logfos.close();
			}
	}

	
	/*operazione di recovery : si suppone sia eseguita su una table nuova,
		a partire da un dump file e un log file
	*/
	
	public synchronized void recovery() throws ClassNotFoundException,InvalidClassException,OptionalDataException,NotSerializableException,NoSuchMethodException,IllegalAccessException,IllegalArgumentException,InvocationTargetException,NullPointerException,ExceptionInInitializerError,StreamCorruptedException,IOException
	{
		synchronized(table)
			{				
				ObjectInputStream dumpois = new ObjectInputStream(new FileInputStream(actual.rcvdump));
				TimeTable ttb = ((TimeTable)dumpois.readObject());
				table.sum(ttb);
				dumpois.close();
			
				ObjectInputStream logois = new ObjectInputStream(new FileInputStream(log));
		
				LogAction temp = ((LogAction)logois.readObject());
	
				while((temp.name)!="")
					{
						((table.getClass()).getMethod(temp.name,temp.parameters)).invoke(table,temp.args);
						temp = ((LogAction)logois.readObject());
					}
		
				logois.close();				
			}				
	}

	
	
}//fine classe