package agenda;

import java.util.*;
import java.io.*;


public class TimeRange implements Serializable, Comparable
{
	protected static final int timeunit = TimeUnit.getAgendaUnit();
	
	protected static final int calendarunit = TimeUnit.toCalendarUnit();
	
	/*public static TimeRange getInstance(Date from, Date to)
	{
		if (from.before(to)) return new TimeRange(from,to)
			else return null	
		
		}*/


	private Date from;
	private Date to;


	public TimeRange(Date start, Date end)
	{
		// le date che uso in questa classe devono avere precisione solo fino al minuto,
		// perci setto i secondi a 0
		
		Date from;
		Date to;
		
		if (start.before(end))
					{from = start;to = end;}
		else	{from = end;to = start;}
		
		this.from = TimeUnit.trunc(from);
		
		this.to = TimeUnit.round(to);

		}
	
	public Date getStartTime()
	{return from;}
	
	public Date getEndTime()
	{return to;}
	
	
	public Durata getLength()
	{
		return TimeUnit.length(this);
	}
	
	
	public int compareTo(Object obj)//throws ClassCastException
	{
		if(obj instanceof TimeRange) return (this.getStartTime()).compareTo(((TimeRange)obj).getStartTime());
			else throw new ClassCastException();
	}
	
	
	public boolean equals(Object obj)
	{
		if(obj instanceof TimeRange) return ((this.compareTo((TimeRange)obj))==0);
		else return false;
	}

	
	
	public boolean overlapandborder(TimeRange tr)
	{
		return (!((from.after(tr.getEndTime()))||(to.before(tr.getStartTime()))));
		}
		
		
	public boolean overlap(TimeRange tr)
	{
		return (!(((from.compareTo(tr.getEndTime()))>=0)||((to.compareTo(tr.getStartTime()))<=0)));
		}

		
	public boolean contains(TimeRange tr)
	{
		return (((from.compareTo(tr.getStartTime()))<=0)&&((to.compareTo(tr.getEndTime()))>=0));
		}
		
	public boolean strictlycontains(TimeRange tr)
	{
		return ((from.before(tr.getStartTime()))&&(to.after(tr.getEndTime())));
		}
	

	
	public boolean strictbefore(TimeRange tr)
	{
		return (to.before(tr.getStartTime()));
		}

	public boolean before(TimeRange tr)
		{
			return ((to.compareTo(tr.getStartTime()))<=0);
			}	
	
	public boolean strictafter(TimeRange tr)
	{
		return (from.after(tr.getEndTime()));
		}

	public boolean after(TimeRange tr)
		{
			return ((from.compareTo(tr.getEndTime()))>=0);
			}	
	
	// il nome isEqual  scelto per non sovrascrivere equals di Object,
	// vedi anche intersection		
	public boolean isEqual(TimeRange tr)
	{
		return (((from.compareTo(tr.getStartTime()))==0)&&((to.compareTo(tr.getEndTime()))==0));
		}
		
	private boolean strictlyin(Date d)
	{
		return ((from.before(d))&&(to.after(d)));
		}	



/* Attenzione : intersection pu restituire il null pointer.
		Chi usa questa operazione deve testare il risultato con == null
		*/
	public TimeRange intersection(TimeRange tr)
	{
		if(!(overlap(tr))) return null;
		
		else if(contains(tr)) return tr;
		
		else if(tr.contains(this)) return this;
		
		else 
			{ 
				if(((this.getStartTime()).after(tr.getStartTime()))&&(strictlyin(tr.getEndTime())))
											return new TimeRange(this.getStartTime(),tr.getEndTime());
				else if(((this.getEndTime()).before(tr.getEndTime()))&&(strictlyin(tr.getStartTime())))
											return new TimeRange(tr.getStartTime(),this.getEndTime());
				
			}
		
		return null;//questo  per il compilatore ma non dovrebbe mai arrivarci						 		
	
	}//fine intersection
		
		
	public TimeTable difference(TimeRange tr)
	{
		if(!(this.overlap(tr)))
						{
							TimeTable ttb = new TimeTable();
							ttb.add(this);
							return ttb;
						}
						
		else if(this.strictlycontains(tr))
								{
									TimeTable ttb = new TimeTable();
									ttb.add(new TimeRange(this.getStartTime(),tr.getStartTime()));
									ttb.add(new TimeRange(tr.getEndTime(),this.getEndTime()));
									return ttb;
								}
					else if(tr.contains(this)) return new TimeTable();
					 		 else {
											TimeTable ttb = new TimeTable();
											if((((this.getStartTime()).compareTo(tr.getStartTime()))>=0)&&(this.strictlyin(tr.getEndTime())))
																	ttb.add(new TimeRange(tr.getEndTime(),this.getEndTime()));
											else if((((this.getEndTime()).compareTo(tr.getEndTime()))<=0)&&(this.strictlyin(tr.getStartTime())))
																	ttb.add(new TimeRange(this.getStartTime(),tr.getStartTime()));
											return ttb;
								 		}
							 		
	}//fine difference

	
}//fine classe