package agenda;

import java.util.*;
import java.io.*;


/*Questa classe non  solo un insieme ordinato di TimeRange,
	ha anche un'invariante: i TimeRange membri dell'insieme
	non si sovrappongono mai
	*/


public class TimeTable implements Serializable
{
	
	private TreeSet table;
	
	
	public TimeTable()
	{
		table = new TreeSet();
	}
	
		
	public TimeTable(TimeTable ttb)
	{
		table = new TreeSet(ttb.table);
	}

	
	public synchronized boolean add(TimeRange tr)
	{
		Iterator it = table.iterator();
		while(it.hasNext())
		{
			if(tr.overlapandborder((TimeRange)it.next()))
				return false;
		}
		table.add(tr);
		return true;
	}
	
	
	public synchronized boolean testforadd(TimeRange tr)
	{
		Iterator it = table.iterator();
		while(it.hasNext())
		{
			if(tr.overlapandborder((TimeRange)it.next()))
				return false;
		}
		return true;
	}

	
	public synchronized boolean remove(TimeRange tr)
	{
		Iterator it = table.iterator();
		while(it.hasNext())
		{
			if(tr.isEqual((TimeRange)it.next()))
			{
				it.remove();
				return true;
			}
		}
		return false;
	}
		
	
	public synchronized void clear()
	{
		table.clear();
	}

	
	public synchronized boolean contains(TimeRange tr)
		{
			Iterator it = table.iterator();
			while(it.hasNext())
			{
				if(tr.isEqual((TimeRange)it.next())) return true;
			}
			return false;
		}

	
	public synchronized boolean isEmpty()
		{
			return table.isEmpty();
		}
	
	
	public synchronized Iterator iterator()
	{
		return table.iterator();
	}

	
	public synchronized TimeTable testforadd(TimeTable ttb)
	{
		TimeTable res = new TimeTable();
		Iterator ttbit = ttb.iterator();
		
		while(ttbit.hasNext())
		{
			TimeRange tr = ((TimeRange)ttbit.next());
			if(testforadd(tr))
				res.add(tr);
		}
		
		return res;
	}
	
	
	public synchronized void sum(TimeTable ttb)
	{
		Iterator ttbit = ttb.iterator();
		
		while(ttbit.hasNext())
		{
			TimeRange tr = ((TimeRange)ttbit.next());
			add(tr);
		}
	
	}
	
	public synchronized TimeTable difference(TimeRange tr)
	{
		TimeTable res = new TimeTable();
		Iterator it = table.iterator();
		
		while(it.hasNext())
		{
			TimeRange ittr = ((TimeRange)it.next());
			TimeTable temp = ittr.difference(tr);
			res.sum(temp);
		}
		
		return res;
	}//fine difference(TimeRange)
		
	
		
	public synchronized TimeTable difference(TimeTable ttb)
	{
		TimeTable res = new TimeTable(this);

		synchronized(ttb)
			{
				Iterator ttbit = ttb.iterator();
		
				while(ttbit.hasNext())
					{
						TimeRange tr = ((TimeRange)ttbit.next());
						res = res.difference(tr);
					}
			}
		
		return res;
	}//fine difference(TimeTable)

	
	
	public synchronized TimeTable intersection(TimeRange tr)
	{
		TimeTable res = new TimeTable();
		Iterator it = table.iterator();
		
		while(it.hasNext())
		{
			TimeRange ittr = ((TimeRange)it.next());
			TimeRange temp = ittr.intersection(tr);
			if (temp != null)
						res.add(temp);
		}
		
		return res;
	}//fine intersection(TimeRange)
		
	
		
	public synchronized TimeTable intersection(TimeTable ttb)
	{
		TimeTable res = new TimeTable();

		synchronized(ttb)
			{
				Iterator ttbit = ttb.iterator();
		
				while(ttbit.hasNext())
					{
						TimeRange tr = ((TimeRange)ttbit.next());
						TimeTable temp = this.intersection(tr);
						res.sum(temp);
					}
			}
		
		return res;
	}//fine intersection(TimeTable)

	
	
	
}//fine classe