package agenda;

import java.util.*;


public class TimeUnit
{
	
	public static final int YEAR = 0;
	public static final int MONTH = 1;
	public static final int DATE = 2;
	public static final int HOUR = 3;
	public static final int MINUTE = 4;
	public static final int SECOND = 5;
	public static final int MILLISECOND = 6;
	
	
	private static final Calendar cal = Calendar.getInstance();

	
	private static int[] units = 
		{
			Calendar.YEAR,
			Calendar.MONTH,
			Calendar.DATE,
			Calendar.HOUR_OF_DAY,
			Calendar.MINUTE,
			Calendar.SECOND,
			Calendar.MILLISECOND
		};
	
	private static int index = MINUTE;
	
	private static int minindex = YEAR;
	
	private static int maxindex = MILLISECOND;
	
	
	public static int toCalendarUnit()
	{return units[index];}
	
	public static int getAgendaUnit()
	{return index;}
	
	/*	public static boolean setAgendaUnit(int unit)
	{
		switch(unit)
			{
				case YEAR :
				case MONTH :
				case DATE :
				case HOUR :
				case MINUTE :
				case SECOND :
				case MILLISECOND :
													index = unit;return true;
				default:
													return false;
			}
	}
*/
	
	/*public static int[] getSubUnits()
	{return units[index];}*/
	
	
	public static Date trunc(Date d)
	{
		synchronized(cal)
		{ 
			cal.setTime(d);
		
			for(int i=index+1;i<=maxindex;i++)
				cal.clear(units[i]);
		
			return cal.getTime();
		}
	
		
	}
	
	public static Date round(Date d)
	{
		synchronized(cal)
		{ 
			cal.setTime(d);
		
			cal.add(units[index],1);
			for(int i=index+1;i<=maxindex;i++)
				cal.clear(units[i]);
		
			return cal.getTime();
		}
	}

	
	public static Durata length(TimeRange tr)
	{
		long count = 0;
		
		synchronized(cal)
		{ 
			cal.setTime(tr.getStartTime());
		
			while(!(((cal.getTime()).compareTo(tr.getEndTime()))==0))
				{
					cal.add(units[index],1);
					count++;
				}
		}
		
		return new Durata(count);
	}
	
	
	
}//fine classe